// Persistence of Vision Ray Tracer Scene Description File
// File: pudding.pov
// Vers: 3.5
// Desc: Ein Vanillepudding fuer das Bielefeld.pm-Logo	
// Date: 20.4.2004
// Auth: Judith Maria Nefertari Dohmann
#version 3.6;
#include "colors.inc"
#include "functions.inc"
#include "math.inc"
global_settings {
  assumed_gamma 1.0
  max_trace_level 5
}
// ----------------------------------------
// set a color of the background (sky)
background { color rgb <1, 1,1 > }


/*light_source {
  <0, 0, 0>            // light's position (translated below)
  color rgb <1, 1, 1>  // light's color
  translate <-50, 30, -30>
}
light_source {
	<0,0,0>
	color rgb <1,1,1>
	translate <50, 30, -30>
	}*/
// ----------------------------------------
/* plane {               // checkered floor
  y, -5
  texture
  {
    pigment {
      checker
      color rgb 1
      color rgb 0.5
      scale 0.5
    }
    finish{
      diffuse 0.8
      ambient 0.1
    }
  }
}
*/ 

#declare r=0.3;
#declare m=3;
#declare R = 1;
#declare n = 7; // sonst 7
#declare d=0.3;
 
//#declare f_halbkreis = function (x,y) { x*x + y*y - r*r};
#declare f_wobbel = function (x,z) {1+d*cos(n*atan2(z,x))*cos(n*atan2(z,x)) };
 


// CSG union, add all of shapes 1...N
union {
isosurface {
  function { max (
  y + m*(sqrt(pow(x,2)+pow(z,2)) - R - r*f_wobbel(x,z) )
    - m*r*f_wobbel(x,z)*(1/sin(atan(m)) -1)
  , y -  1/m*(sqrt(pow(x,2)+pow(z,2)) - R))}
  contained_by { box {<-2.5,-2,-2.5>, <2.5,0.2,2.5>} }  // container shape
  //threshold 0.0                     // optional threshold value for isosurface [0.0]
  accuracy 0.0001                      // accuracy of calculation [0.001]
  max_gradient 4                      // maximum gradient the function can have [1.1]
}
isosurface {
  function { f_torus (x,y,z,R,r*f_wobbel(x,z) )}
  contained_by { box {<-1.4,-0.5,-1.4>, <1.4,0.5,1.4>} }  // container shape
  threshold 0.0                     // optional threshold value for isosurface [0.0]
  accuracy 0.0001                      // accuracy of calculation [0.001]
  max_gradient 3                      // maximum gradient the function can have [1.1]
}
// Capped Cylinder, closed [or open ended]
// cylinder { <END1>, <END2>, RADIUS [open] }
//  END1 = coord of one end of cylinder
//  END2 = coord of other end
// RADIUS = size of cylinder
// open = if present, cylinder is hollow, else capped
cylinder {
  0*x,  -1*y,  1
  // open
}
  texture{
//  pigment {color rgbt <1.0,0.0,0,0.5>}
  pigment {color rgb <1.0,1.0,0.0>}
   finish {
      ambient 0.2
      diffuse 0.6
      //reflection .1
      specular 0.2
      roughness .01
   }  }
  // general media statement
// put in interior or in scene file for atmospheric media


}

// create a regular point light source
light_source {
  0*x                  // light's position (translated below)
  color rgb <1,1,1>    // light's color
  translate <-20, 40, -20>
}
/*// create a regular point light source
light_source {
  0*x                  // light's position (translated below)
  color rgb <1,1,1>    // light's color
  translate <20, 40, -20>
}
*/
// perspective (default) camera
camera {
  location  <1.0, 3.0, -6.0>
  look_at   <0.0, 0.0,  0.0>
  right     x*image_width/image_height
}
